Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Botan::ChaCha_RNG Class Referencefinal

`#include <chacha_rng.h>`

Inheritance diagram for Botan::ChaCha_RNG:

## Public Member Functions
bool | accepts_input () const override final
void | add_entropy (const uint8_t input[], size_t input_len) override final
template<typename T >
void | add_entropy_T (const T &t)
| ChaCha_RNG ()
| ChaCha_RNG (const secure_vector< uint8_t > &seed)
| ChaCha_RNG (Entropy_Sources &entropy_sources, size_t reseed_interval=BOTAN_RNG_DEFAULT_RESEED_INTERVAL)
| ChaCha_RNG (RandomNumberGenerator &underlying_rng, Entropy_Sources &entropy_sources, size_t reseed_interval=BOTAN_RNG_DEFAULT_RESEED_INTERVAL)
| ChaCha_RNG (RandomNumberGenerator &underlying_rng, size_t reseed_interval=BOTAN_RNG_DEFAULT_RESEED_INTERVAL)
void | clear () override final
void | force_reseed ()
void | initialize_with (const uint8_t input[], size_t length)
bool | is_seeded () const override final
size_t | max_number_of_bytes_per_request () const override
std::string | name () const override
uint8_t | next_byte ()
uint8_t | next_nonzero_byte ()
secure_vector< uint8_t > | random_vec (size_t bytes)
template<typename Alloc >
void | random_vec (std::vector< uint8_t, Alloc > &v, size_t bytes)
void | randomize (uint8_t output[], size_t output_len) override final
void | randomize_with_input (uint8_t output[], size_t output_len, const uint8_t input[], size_t input_len) override final
void | randomize_with_ts_input (uint8_t output[], size_t output_len) override final
size_t | reseed (Entropy_Sources &srcs, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS, std::chrono::milliseconds poll_timeout=BOTAN_RNG_RESEED_DEFAULT_TIMEOUT) override
void | reseed_from_rng (RandomNumberGenerator &rng, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS) override final
size_t | reseed_interval () const
size_t | security_level () const override

## Static Public Member Functions
static RandomNumberGenerator * | make_rng ()

## Protected Member Functions
void | reseed_check ()

## Detailed Description

ChaCha_RNG is a very fast but completely ad-hoc RNG created by creating a 256-bit random value and using it as a key for ChaCha20.

The RNG maintains two 256-bit keys, one for HMAC_SHA256 (HK) and the other for ChaCha20 (CK). To compute a new key in response to reseeding request or add_entropy calls, ChaCha_RNG computes CK' = HMAC_SHA256(HK, input_material) Then a new HK' is computed by running ChaCha20 with the new key to output 32 bytes: HK' = ChaCha20(CK')

Now output can be produced by continuing to produce output with ChaCha20 under CK'

The first HK (before seeding occurs) is taken as the all zero value.

Warning
  This RNG construction is probably fine but is non-standard. The primary reason to use it is in cases where the other RNGs are not fast enough.

Definition at line 40 of file chacha_rng.h.

## Constructor & Destructor Documentation

## ◆ ChaCha_RNG() [1/5]

Botan::ChaCha_RNG::ChaCha_RNG | ( |  | ) |

Automatic reseeding is disabled completely, as it has no access to any source for seed material.

If a fork is detected, the RNG will be unable to reseed itself in response. In this case, an exception will be thrown rather than generating duplicated output.

Definition at line 12 of file chacha_rng.cpp.

12 : Stateful_RNG()
13 {
14 m_hmac = MessageAuthenticationCode::create_or_throw("HMAC(SHA-256)");
15 m_chacha = StreamCipher::create_or_throw("ChaCha(20)");
16 clear();
17 }
Botan::MessageAuthenticationCode::create_or_throw
static std::unique_ptr< MessageAuthenticationCode > create_or_throw(const std::string &algo_spec, const std::string &provider="")
Definition: mac.cpp:139
Botan::Stateful_RNG::Stateful_RNG
Stateful_RNG()
Definition: stateful_rng.h:68
Botan::Stateful_RNG::clear
void clear() override final
Definition: stateful_rng.cpp:17
Botan::StreamCipher::create_or_throw
static std::unique_ptr< StreamCipher > create_or_throw(const std::string &algo_spec, const std::string &provider="")
Definition: stream_cipher.cpp:123

References Botan::Stateful_RNG::clear(), Botan::MessageAuthenticationCode::create_or_throw(), and Botan::StreamCipher::create_or_throw().

## ◆ ChaCha_RNG() [2/5]

Botan::ChaCha_RNG::ChaCha_RNG | ( | const secure_vector< uint8_t > & | seed | ) |

Provide an initial seed to the RNG, without providing an underlying RNG or entropy source. Automatic reseeding is disabled completely, as it has no access to any source for seed material.

If a fork is detected, the RNG will be unable to reseed itself in response. In this case, an exception will be thrown rather than generating duplicated output.

Parameters

  seed | the seed material, should be at least 256 bits

Definition at line 19 of file chacha_rng.cpp.

19 : Stateful_RNG()
20 {
21 m_hmac = MessageAuthenticationCode::create_or_throw("HMAC(SHA-256)");
22 m_chacha = StreamCipher::create_or_throw("ChaCha(20)");
23 clear();
24 add_entropy(seed.data(), seed.size());
25 }
Botan::Stateful_RNG::add_entropy
void add_entropy(const uint8_t input[], size_t input_len) override final
Definition: stateful_rng.cpp:37

References Botan::Stateful_RNG::add_entropy(), Botan::Stateful_RNG::clear(), Botan::MessageAuthenticationCode::create_or_throw(), and Botan::StreamCipher::create_or_throw().

## ◆ ChaCha_RNG() [3/5]

Botan::ChaCha_RNG::ChaCha_RNG | ( | RandomNumberGenerator & | underlying_rng,
|  | size_t | reseed_interval = `BOTAN_RNG_DEFAULT_RESEED_INTERVAL`
| ) |  |

Automatic reseeding from `underlying_rng` will take place after `reseed_interval` many requests or after a fork was detected.

Parameters

  underlying_rng | is a reference to some RNG which will be used to perform the periodic reseeding
  reseed_interval | specifies a limit of how many times the RNG will be called before automatic reseeding is performed

Definition at line 27 of file chacha_rng.cpp.

28 :
29 Stateful_RNG(underlying_rng, reseed_interval)
30 {
31 m_hmac = MessageAuthenticationCode::create_or_throw("HMAC(SHA-256)");
32 m_chacha = StreamCipher::create_or_throw("ChaCha(20)");
33 clear();
34 }
Botan::Stateful_RNG::reseed_interval
size_t reseed_interval() const
Definition: stateful_rng.h:128

References Botan::Stateful_RNG::clear(), Botan::MessageAuthenticationCode::create_or_throw(), and Botan::StreamCipher::create_or_throw().

## ◆ ChaCha_RNG() [4/5]

Botan::ChaCha_RNG::ChaCha_RNG | ( | Entropy_Sources & | entropy_sources,
|  | size_t | reseed_interval = `BOTAN_RNG_DEFAULT_RESEED_INTERVAL`
| ) |  |

Automatic reseeding from `entropy_sources` will take place after `reseed_interval` many requests or after a fork was detected.

Parameters

  entropy_sources | will be polled to perform reseeding periodically
  reseed_interval | specifies a limit of how many times the RNG will be called before automatic reseeding is performed.

Definition at line 46 of file chacha_rng.cpp.

47 :
48 Stateful_RNG(entropy_sources, reseed_interval)
49 {
50 m_hmac = MessageAuthenticationCode::create_or_throw("HMAC(SHA-256)");
51 m_chacha = StreamCipher::create_or_throw("ChaCha(20)");
52 clear();
53 }

References Botan::Stateful_RNG::clear(), Botan::MessageAuthenticationCode::create_or_throw(), and Botan::StreamCipher::create_or_throw().

## ◆ ChaCha_RNG() [5/5]

Botan::ChaCha_RNG::ChaCha_RNG | ( | RandomNumberGenerator & | underlying_rng,
|  | Entropy_Sources & | entropy_sources,
|  | size_t | reseed_interval = `BOTAN_RNG_DEFAULT_RESEED_INTERVAL`
| ) |  |

Automatic reseeding from `underlying_rng` and `entropy_sources` will take place after `reseed_interval` many requests or after a fork was detected.

Parameters

  underlying_rng | is a reference to some RNG which will be used to perform the periodic reseeding
  entropy_sources | will be polled to perform reseeding periodically
  reseed_interval | specifies a limit of how many times the RNG will be called before automatic reseeding is performed.

Definition at line 36 of file chacha_rng.cpp.

38 :
39 Stateful_RNG(underlying_rng, entropy_sources, reseed_interval)
40 {
41 m_hmac = MessageAuthenticationCode::create_or_throw("HMAC(SHA-256)");
42 m_chacha = StreamCipher::create_or_throw("ChaCha(20)");
43 clear();
44 }

References Botan::Stateful_RNG::clear(), Botan::MessageAuthenticationCode::create_or_throw(), and Botan::StreamCipher::create_or_throw().

## Member Function Documentation

## ◆ accepts_input()

bool Botan::Stateful_RNG::accepts_input | ( |  | ) | const
| inline final override virtual inherited

Returns false if it is known that this RNG object is not able to accept externally provided inputs (via add_entropy, randomize_with_input, etc). In this case, any such provided inputs are ignored.

If this function returns true, then inputs may or may not be accepted.

Implements Botan::RandomNumberGenerator.

Definition at line 79 of file stateful_rng.h.

79{ return true; }

## ◆ add_entropy()

void Botan::Stateful_RNG::add_entropy | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| final override virtual inherited

Incorporate some additional data into the RNG state. For example adding nonces or timestamps from a peer's protocol message can help hedge against VM state rollback attacks. A few RNG types do not accept any externally provided input, in which case this function is a no-op.

Parameters

  input | a byte array containg the entropy to be added
  length | the length of the byte array in

Implements Botan::RandomNumberGenerator.

Definition at line 37 of file stateful_rng.cpp.

38 {
39 lock_guard_type<recursive_mutex_type> lock(m_mutex);
40
41 update(input, input_len);
42
43 if(8*input_len >= security_level())
44 {
45 reset_reseed_counter();
46 }
47 }
Botan::Stateful_RNG::security_level
virtual size_t security_level() const =0
Botan::Stateful_RNG::update
virtual void update(const uint8_t input[], size_t input_len)=0

References Botan::Stateful_RNG::security_level(), and Botan::Stateful_RNG::update().

Referenced by ChaCha_RNG(), and Botan::Stateful_RNG::initialize_with().

## ◆ add_entropy_T()

template<typename T >

void Botan::RandomNumberGenerator::add_entropy_T | ( | const T & | t | ) |
| inline inherited

Incorporate some additional data into the RNG state.

Definition at line 69 of file rng.h.

70 {
71 static_assert(std::is_standard_layout<T>::value && std::is_trivial<T>::value, "add_entropy_T data must be POD");
72 this->add_entropy(reinterpret_cast<const uint8_t*>(&t), sizeof(T));
73 }
Botan::RandomNumberGenerator::add_entropy
virtual void add_entropy(const uint8_t input[], size_t length)=0
T
fe T
Definition: ge.cpp:37

References T.

Referenced by Botan::Win32_EntropySource::poll().

## ◆ clear()

void Botan::Stateful_RNG::clear | ( |  | ) |
| final override virtual inherited

Clear all internally held values of this RNG

Postcondition
  is_seeded() == false

Implements Botan::RandomNumberGenerator.

Definition at line 17 of file stateful_rng.cpp.

18 {
19 lock_guard_type<recursive_mutex_type> lock(m_mutex);
20 m_reseed_counter = 0;
21 m_last_pid = 0;
22 clear_state();
23 }
Botan::Stateful_RNG::clear_state
virtual void clear_state()=0

References Botan::Stateful_RNG::clear_state().

Referenced by ChaCha_RNG(), Botan::HMAC_DRBG::HMAC_DRBG(), and Botan::Stateful_RNG::initialize_with().

## ◆ force_reseed()

void Botan::Stateful_RNG::force_reseed | ( |  | ) |
| inherited

Mark state as requiring a reseed on next use

Definition at line 25 of file stateful_rng.cpp.

26 {
27 lock_guard_type<recursive_mutex_type> lock(m_mutex);
28 m_reseed_counter = 0;
29 }

## ◆ initialize_with()

void Botan::Stateful_RNG::initialize_with | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| inherited

Consume this input and mark the RNG as initialized regardless of the length of the input or the current seeded state of the RNG.

Definition at line 49 of file stateful_rng.cpp.

50 {
51 lock_guard_type<recursive_mutex_type> lock(m_mutex);
52
53 clear();
54 add_entropy(input, len);
55 }

References Botan::Stateful_RNG::add_entropy(), and Botan::Stateful_RNG::clear().

## ◆ is_seeded()

bool Botan::Stateful_RNG::is_seeded | ( |  | ) | const
| final override virtual inherited

Check whether this RNG is seeded.

Returns
  true if this RNG was already seeded, false otherwise.

Implements Botan::RandomNumberGenerator.

Definition at line 31 of file stateful_rng.cpp.

32 {
33 lock_guard_type<recursive_mutex_type> lock(m_mutex);
34 return m_reseed_counter > 0;
35 }

Referenced by Botan::Stateful_RNG::reseed_check().

## ◆ make_rng()

RandomNumberGenerator * Botan::RandomNumberGenerator::make_rng | ( |  | ) |
| static inherited

Create a seeded and active RNG object for general application use Added in 1.8.0 Use AutoSeeded_RNG instead

Definition at line 69 of file rng.cpp.

70 {
71#if defined(BOTAN_HAS_AUTO_SEEDING_RNG)
72 return new AutoSeeded_RNG;
73#else
74 throw Not_Implemented("make_rng failed, no AutoSeeded_RNG in this build");
75#endif
76 }

## ◆ max_number_of_bytes_per_request()

size_t Botan::ChaCha_RNG::max_number_of_bytes_per_request | ( |  | ) | const
| inline override virtual

Some DRBGs have a notion of the maximum number of bytes per request. Longer requests (to randomize) will be treated as multiple requests, and may initiate reseeding multiple times, depending on the values of max_number_of_bytes_per_request and reseed_interval(). This function returns zero if the RNG in question does not have such a notion.

Returns
  max number of bytes per request (or zero)

Implements Botan::Stateful_RNG.

Definition at line 109 of file chacha_rng.h.

109{ return 0; }

## ◆ name()

std::string Botan::ChaCha_RNG::name | ( |  | ) | const
| inline override virtual

Returns
  the name of this RNG type

Implements Botan::RandomNumberGenerator.

Definition at line 105 of file chacha_rng.h.

105{ return "ChaCha_RNG"; }

## ◆ next_byte()

uint8_t Botan::RandomNumberGenerator::next_byte | ( |  | ) |
| inline inherited

Return a random byte

Returns
  random byte

Definition at line 161 of file rng.h.

162 {
163 uint8_t b;
164 this->randomize(&b, 1);
165 return b;
166 }
Botan::RandomNumberGenerator::randomize
virtual void randomize(uint8_t output[], size_t length)=0

Referenced by Botan::random_prime().

## ◆ next_nonzero_byte()

uint8_t Botan::RandomNumberGenerator::next_nonzero_byte | ( |  | ) |
| inline inherited

Returns
  a random byte that is greater than zero

Definition at line 171 of file rng.h.

172 {
173 uint8_t b = this->next_byte();
174 while(b == 0)
175 b = this->next_byte();
176 return b;
177 }
Botan::RandomNumberGenerator::next_byte
uint8_t next_byte()
Definition: rng.h:161

Referenced by Botan::EME_PKCS1v15::pad().

## ◆ random_vec() [1/2]

secure_vector< uint8_t > Botan::RandomNumberGenerator::random_vec | ( | size_t | bytes | ) |
| inline inherited

Return a random vector

Parameters

  bytes | number of bytes in the result

Returns
  randomized vector of length bytes

Definition at line 143 of file rng.h.

144 {
145 secure_vector<uint8_t> output;
146 random_vec(output, bytes);
147 return output;
148 }
Botan::RandomNumberGenerator::random_vec
secure_vector< uint8_t > random_vec(size_t bytes)
Definition: rng.h:143

Referenced by Botan::CECPQ1_accept(), Botan::CECPQ1_offer(), Botan::TLS::Client_Key_Exchange::Client_Key_Exchange(), Botan::Curve25519_PrivateKey::Curve25519_PrivateKey(), Botan::PK_Decryptor::decrypt_or_random(), Botan::Ed25519_PrivateKey::Ed25519_PrivateKey(), Botan::TLS::Session::encrypt(), Botan::KeyPair::encryption_consistency_check(), Botan::generate_bcrypt(), Botan::mceies_encrypt(), Botan::OctetString::OctetString(), Botan::BigInt::randomize(), and Botan::TLS::Session_Manager_In_Memory::remove_all().

## ◆ random_vec() [2/2]

template<typename Alloc >

void Botan::RandomNumberGenerator::random_vec | ( | std::vector< uint8_t, Alloc > & | v,
|  | size_t | bytes
| ) |  |
| inline inherited

Definition at line 151 of file rng.h.

152 {
153 v.resize(bytes);
154 this->randomize(v.data(), v.size());
155 }

## ◆ randomize()

void Botan::Stateful_RNG::randomize | ( | uint8_t | output[],
|  | size_t | length
| ) |  |
| final override virtual inherited

Randomize a byte array.

Parameters

  output | the byte array to hold the random output.
  length | the length of the byte array output in bytes.

Implements Botan::RandomNumberGenerator.

Definition at line 57 of file stateful_rng.cpp.

58 {
59 randomize_with_input(output, output_len, nullptr, 0);
60 }
Botan::Stateful_RNG::randomize_with_input
void randomize_with_input(uint8_t output[], size_t output_len, const uint8_t input[], size_t input_len) override final
Definition: stateful_rng.cpp:79

References Botan::Stateful_RNG::randomize_with_input().

## ◆ randomize_with_input()

void Botan::Stateful_RNG::randomize_with_input | ( | uint8_t | output[],
|  | size_t | output_len,
|  | const uint8_t | input[],
|  | size_t | input_len
| ) |  |
| final override virtual inherited

Incorporate entropy into the RNG state then produce output. Some RNG types implement this using a single operation, default calls add_entropy + randomize in sequence.

Use this to further bind the outputs to your current process/protocol state. For instance if generating a new key for use in a session, include a session ID or other such value. See NIST SP 800-90 A, B, C series for more ideas.

Parameters

  output | buffer to hold the random output
  output_len | size of the output buffer in bytes
  input | entropy buffer to incorporate
  input_len | size of the input buffer in bytes

Reimplemented from Botan::RandomNumberGenerator.

Definition at line 79 of file stateful_rng.cpp.

81 {
82 if(output_len == 0)
83 return;
84
85 lock_guard_type<recursive_mutex_type> lock(m_mutex);
86
87 const size_t max_per_request = max_number_of_bytes_per_request();
88
89 if(max_per_request == 0) // no limit
90 {
91 reseed_check();
92 this->generate_output(output, output_len, input, input_len);
93 }
94 else
95 {
96 while(output_len > 0)
97 {
98 const size_t this_req = std::min(max_per_request, output_len);
99
100 /*
101 * We split the request into several requests to the underlying DRBG but
102 * pass the input to each invocation. It might be more sensible to only
103 * provide it for the first invocation, however between 2.0 and 2.15
104 * HMAC_DRBG always provided it for all requests so retain that here.
105 */
106
107 reseed_check();
108 this->generate_output(output, this_req, input, input_len);
109
110 output += this_req;
111 output_len -= this_req;
112 }
113 }
114 }
Botan::Stateful_RNG::reseed_check
void reseed_check()
Definition: stateful_rng.cpp:150
Botan::Stateful_RNG::generate_output
virtual void generate_output(uint8_t output[], size_t output_len, const uint8_t input[], size_t input_len)=0
Botan::Stateful_RNG::max_number_of_bytes_per_request
virtual size_t max_number_of_bytes_per_request() const =0

References Botan::Stateful_RNG::generate_output(), Botan::Stateful_RNG::max_number_of_bytes_per_request(), and Botan::Stateful_RNG::reseed_check().

Referenced by Botan::Stateful_RNG::randomize(), and Botan::Stateful_RNG::randomize_with_ts_input().

## ◆ randomize_with_ts_input()

void Botan::Stateful_RNG::randomize_with_ts_input | ( | uint8_t | output[],
|  | size_t | output_len
| ) |  |
| final override virtual inherited

Overrides default implementation and also includes the current process ID and the reseed counter.

Reimplemented from Botan::RandomNumberGenerator.

Definition at line 62 of file stateful_rng.cpp.

63 {
64 uint8_t additional_input[20] = { 0 };
65
66 store_le(OS::get_high_resolution_clock(), additional_input);
67
68#if defined(BOTAN_HAS_SYSTEM_RNG)
69 System_RNG system_rng;
70 system_rng.randomize(additional_input + 8, sizeof(additional_input) - 8);
71#else
72 store_le(OS::get_system_timestamp_ns(), additional_input + 8);
73 store_le(OS::get_process_id(), additional_input + 16);
74#endif
75
76 randomize_with_input(output, output_len, additional_input, sizeof(additional_input));
77 }
Botan::OS::get_high_resolution_clock
uint64_t BOTAN_TEST_API get_high_resolution_clock()
Definition: os_utils.cpp:241
Botan::OS::get_system_timestamp_ns
uint64_t BOTAN_TEST_API get_system_timestamp_ns()
Definition: os_utils.cpp:293
Botan::OS::get_process_id
uint32_t BOTAN_TEST_API get_process_id()
Definition: os_utils.cpp:96
Botan::system_rng
RandomNumberGenerator & system_rng()
Definition: system_rng.cpp:283
Botan::store_le
void store_le(uint16_t in, uint8_t out[2])
Definition: loadstor.h:454

References Botan::OS::get_high_resolution_clock(), Botan::OS::get_process_id(), Botan::OS::get_system_timestamp_ns(), Botan::RandomNumberGenerator::randomize(), Botan::Stateful_RNG::randomize_with_input(), Botan::store_le(), and Botan::system_rng().

## ◆ reseed()

size_t Botan::Stateful_RNG::reseed | ( | Entropy_Sources & | srcs,
|  | size_t | poll_bits = `BOTAN_RNG_RESEED_POLL_BITS`,
|  | std::chrono::milliseconds | poll_timeout = `BOTAN_RNG_RESEED_DEFAULT_TIMEOUT`
| ) |  |
| override virtual inherited

Poll provided sources for up to poll_bits bits of entropy or until the timeout expires. Returns estimate of the number of bits collected.

Reimplemented from Botan::RandomNumberGenerator.

Definition at line 116 of file stateful_rng.cpp.

119 {
120 lock_guard_type<recursive_mutex_type> lock(m_mutex);
121
122 const size_t bits_collected = RandomNumberGenerator::reseed(srcs, poll_bits, poll_timeout);
123
124 if(bits_collected >= security_level())
125 {
126 reset_reseed_counter();
127 }
128
129 return bits_collected;
130 }
Botan::RandomNumberGenerator::reseed
virtual size_t reseed(Entropy_Sources &srcs, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS, std::chrono::milliseconds poll_timeout=BOTAN_RNG_RESEED_DEFAULT_TIMEOUT)
Definition: rng.cpp:45

References Botan::RandomNumberGenerator::reseed(), and Botan::Stateful_RNG::security_level().

Referenced by Botan::Stateful_RNG::reseed_check().

## ◆ reseed_check()

void Botan::Stateful_RNG::reseed_check | ( |  | ) |
| protected inherited

Definition at line 150 of file stateful_rng.cpp.

151 {
152 // Lock is held whenever this function is called
153
154 const uint32_t cur_pid = OS::get_process_id();
155
156 const bool fork_detected = (m_last_pid > 0) && (cur_pid != m_last_pid);
157
158 if(is_seeded() == false ||
159 fork_detected ||
160 (m_reseed_interval > 0 && m_reseed_counter >= m_reseed_interval))
161 {
162 m_reseed_counter = 0;
163 m_last_pid = cur_pid;
164
165 if(m_underlying_rng)
166 {
167 reseed_from_rng(*m_underlying_rng, security_level());
168 }
169
170 if(m_entropy_sources)
171 {
172 reseed(*m_entropy_sources, security_level());
173 }
174
175 if(!is_seeded())
176 {
177 if(fork_detected)
178 throw Invalid_State("Detected use of fork but cannot reseed DRBG");
179 else
180 throw PRNG_Unseeded(name());
181 }
182 }
183 else
184 {
185 BOTAN_ASSERT(m_reseed_counter != 0, "RNG is seeded");
186 m_reseed_counter += 1;
187 }
188 }
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:55
Botan::RandomNumberGenerator::name
virtual std::string name() const =0
Botan::Stateful_RNG::reseed
size_t reseed(Entropy_Sources &srcs, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS, std::chrono::milliseconds poll_timeout=BOTAN_RNG_RESEED_DEFAULT_TIMEOUT) override
Definition: stateful_rng.cpp:116
Botan::Stateful_RNG::is_seeded
bool is_seeded() const override final
Definition: stateful_rng.cpp:31
Botan::Stateful_RNG::reseed_from_rng
void reseed_from_rng(RandomNumberGenerator &rng, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS) override final
Definition: stateful_rng.cpp:132

References BOTAN_ASSERT, Botan::OS::get_process_id(), Botan::Stateful_RNG::is_seeded(), Botan::RandomNumberGenerator::name(), Botan::Stateful_RNG::reseed(), Botan::Stateful_RNG::reseed_from_rng(), and Botan::Stateful_RNG::security_level().

Referenced by Botan::Stateful_RNG::randomize_with_input().

## ◆ reseed_from_rng()

void Botan::Stateful_RNG::reseed_from_rng | ( | RandomNumberGenerator & | rng,
|  | size_t | poll_bits = `BOTAN_RNG_RESEED_POLL_BITS`
| ) |  |
| final override virtual inherited

Reseed by reading specified bits from the RNG

Reimplemented from Botan::RandomNumberGenerator.

Definition at line 132 of file stateful_rng.cpp.

133 {
134 lock_guard_type<recursive_mutex_type> lock(m_mutex);
135
136 RandomNumberGenerator::reseed_from_rng(rng, poll_bits);
137
138 if(poll_bits >= security_level())
139 {
140 reset_reseed_counter();
141 }
142 }
Botan::RandomNumberGenerator::reseed_from_rng
virtual void reseed_from_rng(RandomNumberGenerator &rng, size_t poll_bits=BOTAN_RNG_RESEED_POLL_BITS)
Definition: rng.cpp:59

References Botan::RandomNumberGenerator::reseed_from_rng(), and Botan::Stateful_RNG::security_level().

Referenced by Botan::Stateful_RNG::reseed_check().

## ◆ reseed_interval()

size_t Botan::Stateful_RNG::reseed_interval | ( |  | ) | const
| inline inherited

Definition at line 128 of file stateful_rng.h.

128{ return m_reseed_interval; }

Referenced by Botan::HMAC_DRBG::HMAC_DRBG().

## ◆ security_level()

size_t Botan::ChaCha_RNG::security_level | ( |  | ) | const
| override virtual

Returns
  intended security level of this DRBG

Implements Botan::Stateful_RNG.

Definition at line 82 of file chacha_rng.cpp.

83 {
84 return 256;
85 }

The documentation for this class was generated from the following files:

- src/lib/rng/chacha_rng/chacha_rng.h
- src/lib/rng/chacha_rng/chacha_rng.cpp